      SUBROUTINE EKSCX(BX,S,UZ,RHX,IJ,INX1,INX2,EZS,ERS,EZC,ERC,
     & ZEZK,ERK)
C ***
C     COMPUTE E FIELD OF SINE, COSINE, AND CONSTANT CURRENT FILAMENTS BY
C     EXTENDED THIN WIRE APPROXIMATION.
      INCLUDE 'prec.inc'
      INCLUDE 'header.inc'
      COMPLEX*16  CON, GZ1, GZ2, GZP1, GZP2, GR1, GR2, GRP1, GRP2, EZS,
     & EZC, ERS, ERC, GRK1, GRK2, ERK, GZZ1, GZZ2, GZPD
      COMMON  /TMI/ UZPK, RKB2, IJX
      PARAMETER (PI=3.141592653589793D0)
      DIMENSION  CONX(2)
      EQUIVALENCE(CONX,CON)
      DATA   CONX/0.,4.771341189D+0/
      IF( RHX.LT. BX) GOTO 1
      RH= RHX
      B= BX
      IRA=0
      GOTO 2
    1 RH= BX
      B= RHX
      IRA=1
    2 SH=.5* S
      IJX= IJ
      UZPK= 2*PI* UZ
      RHK= 2*PI* RH
      RKB2= RHK* RHK
      SHK= 2*PI* SH
      SS= SIN( SHK)
      CS= COS( SHK)
      RZ2= SH- UZ
      RZ1=-( SH+ UZ)
      A2= B* B
      IF( INX1.EQ.2) GOTO 3
      CALL GXX( RZ1, RH, B, A2, IRA, GZ1, GZP1, GR1, GRP1, GRK1,
     &GZZ1)
      GOTO 4
    3 CALL GX( RZ1, RHX, 2*PI, GZ1, GRK1)
      GZP1= GRK1* RZ1
      GR1= GZ1/ RHX
      GRP1= GZP1/ RHX
      GRK1= GRK1* RHX
      GZZ1=(0.,0.)
    4 IF( INX2.EQ.2) GOTO 5
      CALL GXX( RZ2, RH, B, A2, IRA, GZ2, GZP2, GR2, GRP2, GRK2,
     &GZZ2)
      GOTO 6
    5 CALL GX( RZ2, RHX, 2*PI, GZ2, GRK2)
      GZP2= GRK2* RZ2
      GR2= GZ2/ RHX
      GRP2= GZP2/ RHX
      GRK2= GRK2* RHX
      GZZ2=(0.,0.)
    6 CONTINUE
      CSXK=CS*2*PI
      SSXK=SS*2*PI
      GZPD=GZP2-GZP1
      GRP2=GRP2*RZ2+GR2
      GRP1=GRP1*RZ1+GR1
      GR2=GR2*RZ2
      GR1=GR1*RZ1
      EZS= CON*( (GZ2-GZ1)*CSXK - (GZP2+GZP1)*SS )
      EZC=-CON*( (GZ2+GZ1)*SSXK + GZPD*CS )
      ERS=-CON*( (GRP2+GRP1)*SS - (GR2-GR1)*CSXK )
      ERC=-CON*( (GRP2-GRP1)*CS + (GR2+GR1)*SSXK )
      ERK= CON*( GRK2- GRK1)
      CALL INTX(- SHK, SHK, RHK, IJ, CINT, SINT)
      BK= B* 2*PI
      BK2= BK* BK*.25
      ZEZK=- CON*( GZPD + 2*PI* 2*PI*(1.- BK2)* CMPLX( CINT,- SINT)-
     &BK2*( GZZ2- GZZ1))
      RETURN
      END
